﻿Imports System.IO
Imports System.Drawing.Imaging
Imports System.Data.OleDb

Public Class Main
    Dim Con As OleDbConnection = New OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & Application.StartupPath & "\Image.accdb")
    Dim Cmd As New OleDbCommand
    Dim Da As New OleDbDataAdapter

    Private ImagePath As String = ""

    Public Function ImageToBase64(ByVal image As Image, ByVal format As System.Drawing.Imaging.ImageFormat) As String
        Using ms As New MemoryStream()
            ' Convert Image to byte[]
            image.Save(ms, format)
            Dim imageBytes As Byte() = ms.ToArray()

            ' Convert byte[] to Base64 String
            Dim base64String As String = Convert.ToBase64String(imageBytes)
            Return base64String
        End Using
    End Function

    Public Function Base64ToImage(ByVal base64String As String) As Image
        ' Convert Base64 String to byte[]
        Dim imageBytes As Byte() = Convert.FromBase64String(base64String)
        Dim ms As New MemoryStream(imageBytes, 0, imageBytes.Length)

        ' Convert byte[] to Image
        ms.Write(imageBytes, 0, imageBytes.Length)
        Dim ConvertedBase64Image As Image = Image.FromStream(ms, True)
        Return ConvertedBase64Image
    End Function

    Private Sub BtnImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnConvertToBase64.Click
        OfdImage.ShowDialog()
        If My.Computer.FileSystem.FileExists(ImagePath) Then
            Dim ImageToConvert As Bitmap = Bitmap.FromFile(ImagePath)
            TxtBase64.Text = ImageToBase64(ImageToConvert, ImageFormat.Png)
        End If

        Try
            Con.Open()
            Cmd = New OleDbCommand(String.Format("INSERT INTO Images ( DateCreated, ImageCode) VALUES('{0}', '{1}')", Date.Now, TxtBase64.Text), Con)
            Dim Result = Cmd.ExecuteNonQuery()
            If Result > 0 Then
                MessageBox.Show("Added image successfully!")
            End If
            Con.Close()

            TxtBase64.Clear()
        Catch ex As Exception
        End Try
        
    End Sub

    Private Sub BtnConvertToImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnConvertToImage.Click
        PicImage.Image = Base64ToImage(TxtBase64.Text)
    End Sub

    Private Sub OfdImage_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OfdImage.FileOk
        ImagePath = OfdImage.FileName
    End Sub

    Private Sub Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        OfdImage.Filter = "JPG| *.jpg|GIF| *.gif|PNG| *.png|Bitmap| *.bmp|All Files|*.*"
    End Sub

    Private Sub BtnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddNew.Click
        TxtBase64.Clear()
        PicImage.Image = Nothing
    End Sub

    Private Sub PicImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PicImage.Click

    End Sub
End Class
